// services/network/public/mojom/network_param.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_PARAM_MOJOM_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_PARAM_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include <optional>
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/network/public/mojom/network_param.mojom-features.h"
#include "services/network/public/mojom/network_param.mojom-shared.h"
#include "services/network/public/mojom/network_param.mojom-forward.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "url/mojom/scheme_host_port.mojom.h"
#include <string>
#include <vector>




#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "services/network/public/cpp/net_ipc_param_traits.h"
#include "services/network/public/cpp/network_param_mojom_traits.h"




namespace network::mojom {









class  HttpVersion {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HttpVersion, T>::value>;
  using DataView = HttpVersionDataView;
  using Data_ = internal::HttpVersion_Data;

  template <typename... Args>
  static HttpVersionPtr New(Args&&... args) {
    return HttpVersionPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HttpVersionPtr From(const U& u) {
    return mojo::TypeConverter<HttpVersionPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HttpVersion>::Convert(*this);
  }


  HttpVersion();

  HttpVersion(
      uint16_t major_value,
      uint16_t minor_value);


  ~HttpVersion();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HttpVersionPtr>
  HttpVersionPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HttpVersion::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HttpVersion::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, HttpVersion::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HttpVersion::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HttpVersion::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HttpVersion_UnserializedMessageContext<
            UserType, HttpVersion::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HttpVersion::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HttpVersion::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HttpVersion_UnserializedMessageContext<
            UserType, HttpVersion::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HttpVersion::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint16_t major_value;
  
  uint16_t minor_value;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HttpVersion::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HttpVersion::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HttpVersion::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HttpVersion::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  HostPortPair {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<HostPortPair, T>::value>;
  using DataView = HostPortPairDataView;
  using Data_ = internal::HostPortPair_Data;

  template <typename... Args>
  static HostPortPairPtr New(Args&&... args) {
    return HostPortPairPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static HostPortPairPtr From(const U& u) {
    return mojo::TypeConverter<HostPortPairPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, HostPortPair>::Convert(*this);
  }


  HostPortPair();

  HostPortPair(
      const std::string& host,
      uint16_t port);


  ~HostPortPair();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = HostPortPairPtr>
  HostPortPairPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, HostPortPair::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, HostPortPair::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, HostPortPair::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        HostPortPair::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        HostPortPair::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::HostPortPair_UnserializedMessageContext<
            UserType, HostPortPair::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<HostPortPair::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return HostPortPair::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::HostPortPair_UnserializedMessageContext<
            UserType, HostPortPair::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<HostPortPair::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::string host;
  
  uint16_t port;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, HostPortPair::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, HostPortPair::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, HostPortPair::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, HostPortPair::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  ResolveErrorInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ResolveErrorInfo, T>::value>;
  using DataView = ResolveErrorInfoDataView;
  using Data_ = internal::ResolveErrorInfo_Data;

  template <typename... Args>
  static ResolveErrorInfoPtr New(Args&&... args) {
    return ResolveErrorInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ResolveErrorInfoPtr From(const U& u) {
    return mojo::TypeConverter<ResolveErrorInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ResolveErrorInfo>::Convert(*this);
  }


  ResolveErrorInfo();

  ResolveErrorInfo(
      int32_t error,
      bool is_secure_network_error);


  ~ResolveErrorInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ResolveErrorInfoPtr>
  ResolveErrorInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ResolveErrorInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ResolveErrorInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ResolveErrorInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ResolveErrorInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ResolveErrorInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ResolveErrorInfo_UnserializedMessageContext<
            UserType, ResolveErrorInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ResolveErrorInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ResolveErrorInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ResolveErrorInfo_UnserializedMessageContext<
            UserType, ResolveErrorInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ResolveErrorInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  int32_t error;
  
  bool is_secure_network_error;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ResolveErrorInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ResolveErrorInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ResolveErrorInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ResolveErrorInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}











class  AuthChallengeInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AuthChallengeInfo, T>::value>;
  using DataView = AuthChallengeInfoDataView;
  using Data_ = internal::AuthChallengeInfo_Data;

  template <typename... Args>
  static AuthChallengeInfoPtr New(Args&&... args) {
    return AuthChallengeInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AuthChallengeInfoPtr From(const U& u) {
    return mojo::TypeConverter<AuthChallengeInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AuthChallengeInfo>::Convert(*this);
  }


  AuthChallengeInfo();

  AuthChallengeInfo(
      bool is_proxy,
      const ::url::SchemeHostPort& challenger,
      const std::string& scheme,
      const std::string& realm,
      const std::string& challenge,
      const std::string& path);


  ~AuthChallengeInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AuthChallengeInfoPtr>
  AuthChallengeInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AuthChallengeInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AuthChallengeInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, AuthChallengeInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AuthChallengeInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AuthChallengeInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AuthChallengeInfo_UnserializedMessageContext<
            UserType, AuthChallengeInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AuthChallengeInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AuthChallengeInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AuthChallengeInfo_UnserializedMessageContext<
            UserType, AuthChallengeInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AuthChallengeInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  bool is_proxy;
  
  ::url::SchemeHostPort challenger;
  
  std::string scheme;
  
  std::string realm;
  
  std::string challenge;
  
  std::string path;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AuthChallengeInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AuthChallengeInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AuthChallengeInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AuthChallengeInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}










class  ProxyServer {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ProxyServer, T>::value>;
  using DataView = ProxyServerDataView;
  using Data_ = internal::ProxyServer_Data;

  template <typename... Args>
  static ProxyServerPtr New(Args&&... args) {
    return ProxyServerPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ProxyServerPtr From(const U& u) {
    return mojo::TypeConverter<ProxyServerPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ProxyServer>::Convert(*this);
  }


  ProxyServer();

  ProxyServer(
      ::net::ProxyServer::Scheme scheme,
      const std::optional<::net::HostPortPair>& host_and_port);


  ~ProxyServer();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ProxyServerPtr>
  ProxyServerPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ProxyServer::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ProxyServer::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ProxyServer::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ProxyServer::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ProxyServer::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ProxyServer_UnserializedMessageContext<
            UserType, ProxyServer::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ProxyServer::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ProxyServer::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ProxyServer_UnserializedMessageContext<
            UserType, ProxyServer::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ProxyServer::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::net::ProxyServer::Scheme scheme;
  
  std::optional<::net::HostPortPair> host_and_port;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ProxyServer::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ProxyServer::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ProxyServer::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ProxyServer::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  ProxyChain {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ProxyChain, T>::value>;
  using DataView = ProxyChainDataView;
  using Data_ = internal::ProxyChain_Data;

  template <typename... Args>
  static ProxyChainPtr New(Args&&... args) {
    return ProxyChainPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ProxyChainPtr From(const U& u) {
    return mojo::TypeConverter<ProxyChainPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ProxyChain>::Convert(*this);
  }


  ProxyChain();

  ProxyChain(
      std::optional<std::vector<::net::ProxyServer>> proxy_servers,
      bool is_for_ip_protection);


  ~ProxyChain();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ProxyChainPtr>
  ProxyChainPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ProxyChain::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ProxyChain::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ProxyChain::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ProxyChain::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ProxyChain::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ProxyChain_UnserializedMessageContext<
            UserType, ProxyChain::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ProxyChain::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ProxyChain::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ProxyChain_UnserializedMessageContext<
            UserType, ProxyChain::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ProxyChain::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  std::optional<std::vector<::net::ProxyServer>> proxy_servers;
  
  bool is_for_ip_protection;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ProxyChain::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ProxyChain::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ProxyChain::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ProxyChain::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}






class  SSLCertRequestInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<SSLCertRequestInfo, T>::value>;
  using DataView = SSLCertRequestInfoDataView;
  using Data_ = internal::SSLCertRequestInfo_Data;

  template <typename... Args>
  static SSLCertRequestInfoPtr New(Args&&... args) {
    return SSLCertRequestInfoPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static SSLCertRequestInfoPtr From(const U& u) {
    return mojo::TypeConverter<SSLCertRequestInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, SSLCertRequestInfo>::Convert(*this);
  }


  SSLCertRequestInfo();

  SSLCertRequestInfo(
      const ::net::HostPortPair& host_and_port,
      bool is_proxy,
      std::vector<std::string> cert_authorities,
      std::vector<uint16_t> signature_algorithms);


  ~SSLCertRequestInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = SSLCertRequestInfoPtr>
  SSLCertRequestInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, SSLCertRequestInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, SSLCertRequestInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, SSLCertRequestInfo::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        SSLCertRequestInfo::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        SSLCertRequestInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::SSLCertRequestInfo_UnserializedMessageContext<
            UserType, SSLCertRequestInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<SSLCertRequestInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return SSLCertRequestInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::SSLCertRequestInfo_UnserializedMessageContext<
            UserType, SSLCertRequestInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<SSLCertRequestInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::net::HostPortPair host_and_port;
  
  bool is_proxy;
  
  std::vector<std::string> cert_authorities;
  
  std::vector<uint16_t> signature_algorithms;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, SSLCertRequestInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, SSLCertRequestInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, SSLCertRequestInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, SSLCertRequestInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}







class  NetLogSource {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<NetLogSource, T>::value>;
  using DataView = NetLogSourceDataView;
  using Data_ = internal::NetLogSource_Data;

  template <typename... Args>
  static NetLogSourcePtr New(Args&&... args) {
    return NetLogSourcePtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static NetLogSourcePtr From(const U& u) {
    return mojo::TypeConverter<NetLogSourcePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, NetLogSource>::Convert(*this);
  }


  NetLogSource();

  NetLogSource(
      uint32_t source_type,
      uint32_t source_id,
      ::base::TimeTicks start_time);


  ~NetLogSource();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = NetLogSourcePtr>
  NetLogSourcePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, NetLogSource::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, NetLogSource::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, NetLogSource::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        NetLogSource::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        NetLogSource::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::NetLogSource_UnserializedMessageContext<
            UserType, NetLogSource::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<NetLogSource::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return NetLogSource::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::NetLogSource_UnserializedMessageContext<
            UserType, NetLogSource::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<NetLogSource::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  uint32_t source_type;
  
  uint32_t source_id;
  
  ::base::TimeTicks start_time;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, NetLogSource::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, NetLogSource::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, NetLogSource::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, NetLogSource::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AuthChallengeInfoPtr AuthChallengeInfo::Clone() const {
  return New(
      mojo::Clone(is_proxy),
      mojo::Clone(challenger),
      mojo::Clone(scheme),
      mojo::Clone(realm),
      mojo::Clone(challenge),
      mojo::Clone(path)
  );
}

template <typename T, AuthChallengeInfo::EnableIfSame<T>*>
bool AuthChallengeInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->is_proxy, other_struct.is_proxy))
    return false;
  if (!mojo::Equals(this->challenger, other_struct.challenger))
    return false;
  if (!mojo::Equals(this->scheme, other_struct.scheme))
    return false;
  if (!mojo::Equals(this->realm, other_struct.realm))
    return false;
  if (!mojo::Equals(this->challenge, other_struct.challenge))
    return false;
  if (!mojo::Equals(this->path, other_struct.path))
    return false;
  return true;
}

template <typename T, AuthChallengeInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.is_proxy < rhs.is_proxy)
    return true;
  if (rhs.is_proxy < lhs.is_proxy)
    return false;
  if (lhs.challenger < rhs.challenger)
    return true;
  if (rhs.challenger < lhs.challenger)
    return false;
  if (lhs.scheme < rhs.scheme)
    return true;
  if (rhs.scheme < lhs.scheme)
    return false;
  if (lhs.realm < rhs.realm)
    return true;
  if (rhs.realm < lhs.realm)
    return false;
  if (lhs.challenge < rhs.challenge)
    return true;
  if (rhs.challenge < lhs.challenge)
    return false;
  if (lhs.path < rhs.path)
    return true;
  if (rhs.path < lhs.path)
    return false;
  return false;
}
template <typename StructPtrType>
HttpVersionPtr HttpVersion::Clone() const {
  return New(
      mojo::Clone(major_value),
      mojo::Clone(minor_value)
  );
}

template <typename T, HttpVersion::EnableIfSame<T>*>
bool HttpVersion::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->major_value, other_struct.major_value))
    return false;
  if (!mojo::Equals(this->minor_value, other_struct.minor_value))
    return false;
  return true;
}

template <typename T, HttpVersion::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.major_value < rhs.major_value)
    return true;
  if (rhs.major_value < lhs.major_value)
    return false;
  if (lhs.minor_value < rhs.minor_value)
    return true;
  if (rhs.minor_value < lhs.minor_value)
    return false;
  return false;
}
template <typename StructPtrType>
HostPortPairPtr HostPortPair::Clone() const {
  return New(
      mojo::Clone(host),
      mojo::Clone(port)
  );
}

template <typename T, HostPortPair::EnableIfSame<T>*>
bool HostPortPair::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->host, other_struct.host))
    return false;
  if (!mojo::Equals(this->port, other_struct.port))
    return false;
  return true;
}

template <typename T, HostPortPair::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.host < rhs.host)
    return true;
  if (rhs.host < lhs.host)
    return false;
  if (lhs.port < rhs.port)
    return true;
  if (rhs.port < lhs.port)
    return false;
  return false;
}
template <typename StructPtrType>
ProxyServerPtr ProxyServer::Clone() const {
  return New(
      mojo::Clone(scheme),
      mojo::Clone(host_and_port)
  );
}

template <typename T, ProxyServer::EnableIfSame<T>*>
bool ProxyServer::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->scheme, other_struct.scheme))
    return false;
  if (!mojo::Equals(this->host_and_port, other_struct.host_and_port))
    return false;
  return true;
}

template <typename T, ProxyServer::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.scheme < rhs.scheme)
    return true;
  if (rhs.scheme < lhs.scheme)
    return false;
  if (lhs.host_and_port < rhs.host_and_port)
    return true;
  if (rhs.host_and_port < lhs.host_and_port)
    return false;
  return false;
}
template <typename StructPtrType>
ProxyChainPtr ProxyChain::Clone() const {
  return New(
      mojo::Clone(proxy_servers),
      mojo::Clone(is_for_ip_protection)
  );
}

template <typename T, ProxyChain::EnableIfSame<T>*>
bool ProxyChain::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->proxy_servers, other_struct.proxy_servers))
    return false;
  if (!mojo::Equals(this->is_for_ip_protection, other_struct.is_for_ip_protection))
    return false;
  return true;
}

template <typename T, ProxyChain::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.proxy_servers < rhs.proxy_servers)
    return true;
  if (rhs.proxy_servers < lhs.proxy_servers)
    return false;
  if (lhs.is_for_ip_protection < rhs.is_for_ip_protection)
    return true;
  if (rhs.is_for_ip_protection < lhs.is_for_ip_protection)
    return false;
  return false;
}
template <typename StructPtrType>
ResolveErrorInfoPtr ResolveErrorInfo::Clone() const {
  return New(
      mojo::Clone(error),
      mojo::Clone(is_secure_network_error)
  );
}

template <typename T, ResolveErrorInfo::EnableIfSame<T>*>
bool ResolveErrorInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->error, other_struct.error))
    return false;
  if (!mojo::Equals(this->is_secure_network_error, other_struct.is_secure_network_error))
    return false;
  return true;
}

template <typename T, ResolveErrorInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.error < rhs.error)
    return true;
  if (rhs.error < lhs.error)
    return false;
  if (lhs.is_secure_network_error < rhs.is_secure_network_error)
    return true;
  if (rhs.is_secure_network_error < lhs.is_secure_network_error)
    return false;
  return false;
}
template <typename StructPtrType>
SSLCertRequestInfoPtr SSLCertRequestInfo::Clone() const {
  return New(
      mojo::Clone(host_and_port),
      mojo::Clone(is_proxy),
      mojo::Clone(cert_authorities),
      mojo::Clone(signature_algorithms)
  );
}

template <typename T, SSLCertRequestInfo::EnableIfSame<T>*>
bool SSLCertRequestInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->host_and_port, other_struct.host_and_port))
    return false;
  if (!mojo::Equals(this->is_proxy, other_struct.is_proxy))
    return false;
  if (!mojo::Equals(this->cert_authorities, other_struct.cert_authorities))
    return false;
  if (!mojo::Equals(this->signature_algorithms, other_struct.signature_algorithms))
    return false;
  return true;
}

template <typename T, SSLCertRequestInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.host_and_port < rhs.host_and_port)
    return true;
  if (rhs.host_and_port < lhs.host_and_port)
    return false;
  if (lhs.is_proxy < rhs.is_proxy)
    return true;
  if (rhs.is_proxy < lhs.is_proxy)
    return false;
  if (lhs.cert_authorities < rhs.cert_authorities)
    return true;
  if (rhs.cert_authorities < lhs.cert_authorities)
    return false;
  if (lhs.signature_algorithms < rhs.signature_algorithms)
    return true;
  if (rhs.signature_algorithms < lhs.signature_algorithms)
    return false;
  return false;
}
template <typename StructPtrType>
NetLogSourcePtr NetLogSource::Clone() const {
  return New(
      mojo::Clone(source_type),
      mojo::Clone(source_id),
      mojo::Clone(start_time)
  );
}

template <typename T, NetLogSource::EnableIfSame<T>*>
bool NetLogSource::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->source_type, other_struct.source_type))
    return false;
  if (!mojo::Equals(this->source_id, other_struct.source_id))
    return false;
  if (!mojo::Equals(this->start_time, other_struct.start_time))
    return false;
  return true;
}

template <typename T, NetLogSource::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.source_type < rhs.source_type)
    return true;
  if (rhs.source_type < lhs.source_type)
    return false;
  if (lhs.source_id < rhs.source_id)
    return true;
  if (rhs.source_id < lhs.source_id)
    return false;
  if (lhs.start_time < rhs.start_time)
    return true;
  if (rhs.start_time < lhs.start_time)
    return false;
  return false;
}


}  // network::mojom

namespace mojo {


template <>
struct  StructTraits<::network::mojom::AuthChallengeInfo::DataView,
                                         ::network::mojom::AuthChallengeInfoPtr> {
  static bool IsNull(const ::network::mojom::AuthChallengeInfoPtr& input) { return !input; }
  static void SetToNull(::network::mojom::AuthChallengeInfoPtr* output) { output->reset(); }

  static decltype(::network::mojom::AuthChallengeInfo::is_proxy) is_proxy(
      const ::network::mojom::AuthChallengeInfoPtr& input) {
    return input->is_proxy;
  }

  static const decltype(::network::mojom::AuthChallengeInfo::challenger)& challenger(
      const ::network::mojom::AuthChallengeInfoPtr& input) {
    return input->challenger;
  }

  static const decltype(::network::mojom::AuthChallengeInfo::scheme)& scheme(
      const ::network::mojom::AuthChallengeInfoPtr& input) {
    return input->scheme;
  }

  static const decltype(::network::mojom::AuthChallengeInfo::realm)& realm(
      const ::network::mojom::AuthChallengeInfoPtr& input) {
    return input->realm;
  }

  static const decltype(::network::mojom::AuthChallengeInfo::challenge)& challenge(
      const ::network::mojom::AuthChallengeInfoPtr& input) {
    return input->challenge;
  }

  static const decltype(::network::mojom::AuthChallengeInfo::path)& path(
      const ::network::mojom::AuthChallengeInfoPtr& input) {
    return input->path;
  }

  static bool Read(::network::mojom::AuthChallengeInfo::DataView input, ::network::mojom::AuthChallengeInfoPtr* output);
};


template <>
struct  StructTraits<::network::mojom::HttpVersion::DataView,
                                         ::network::mojom::HttpVersionPtr> {
  static bool IsNull(const ::network::mojom::HttpVersionPtr& input) { return !input; }
  static void SetToNull(::network::mojom::HttpVersionPtr* output) { output->reset(); }

  static decltype(::network::mojom::HttpVersion::major_value) major_value(
      const ::network::mojom::HttpVersionPtr& input) {
    return input->major_value;
  }

  static decltype(::network::mojom::HttpVersion::minor_value) minor_value(
      const ::network::mojom::HttpVersionPtr& input) {
    return input->minor_value;
  }

  static bool Read(::network::mojom::HttpVersion::DataView input, ::network::mojom::HttpVersionPtr* output);
};


template <>
struct  StructTraits<::network::mojom::HostPortPair::DataView,
                                         ::network::mojom::HostPortPairPtr> {
  static bool IsNull(const ::network::mojom::HostPortPairPtr& input) { return !input; }
  static void SetToNull(::network::mojom::HostPortPairPtr* output) { output->reset(); }

  static const decltype(::network::mojom::HostPortPair::host)& host(
      const ::network::mojom::HostPortPairPtr& input) {
    return input->host;
  }

  static decltype(::network::mojom::HostPortPair::port) port(
      const ::network::mojom::HostPortPairPtr& input) {
    return input->port;
  }

  static bool Read(::network::mojom::HostPortPair::DataView input, ::network::mojom::HostPortPairPtr* output);
};


template <>
struct  StructTraits<::network::mojom::ProxyServer::DataView,
                                         ::network::mojom::ProxyServerPtr> {
  static bool IsNull(const ::network::mojom::ProxyServerPtr& input) { return !input; }
  static void SetToNull(::network::mojom::ProxyServerPtr* output) { output->reset(); }

  static decltype(::network::mojom::ProxyServer::scheme) scheme(
      const ::network::mojom::ProxyServerPtr& input) {
    return input->scheme;
  }

  static const decltype(::network::mojom::ProxyServer::host_and_port)& host_and_port(
      const ::network::mojom::ProxyServerPtr& input) {
    return input->host_and_port;
  }

  static bool Read(::network::mojom::ProxyServer::DataView input, ::network::mojom::ProxyServerPtr* output);
};


template <>
struct  StructTraits<::network::mojom::ProxyChain::DataView,
                                         ::network::mojom::ProxyChainPtr> {
  static bool IsNull(const ::network::mojom::ProxyChainPtr& input) { return !input; }
  static void SetToNull(::network::mojom::ProxyChainPtr* output) { output->reset(); }

  static const decltype(::network::mojom::ProxyChain::proxy_servers)& proxy_servers(
      const ::network::mojom::ProxyChainPtr& input) {
    return input->proxy_servers;
  }

  static decltype(::network::mojom::ProxyChain::is_for_ip_protection) is_for_ip_protection(
      const ::network::mojom::ProxyChainPtr& input) {
    return input->is_for_ip_protection;
  }

  static bool Read(::network::mojom::ProxyChain::DataView input, ::network::mojom::ProxyChainPtr* output);
};


template <>
struct  StructTraits<::network::mojom::ResolveErrorInfo::DataView,
                                         ::network::mojom::ResolveErrorInfoPtr> {
  static bool IsNull(const ::network::mojom::ResolveErrorInfoPtr& input) { return !input; }
  static void SetToNull(::network::mojom::ResolveErrorInfoPtr* output) { output->reset(); }

  static decltype(::network::mojom::ResolveErrorInfo::error) error(
      const ::network::mojom::ResolveErrorInfoPtr& input) {
    return input->error;
  }

  static decltype(::network::mojom::ResolveErrorInfo::is_secure_network_error) is_secure_network_error(
      const ::network::mojom::ResolveErrorInfoPtr& input) {
    return input->is_secure_network_error;
  }

  static bool Read(::network::mojom::ResolveErrorInfo::DataView input, ::network::mojom::ResolveErrorInfoPtr* output);
};


template <>
struct  StructTraits<::network::mojom::SSLCertRequestInfo::DataView,
                                         ::network::mojom::SSLCertRequestInfoPtr> {
  static bool IsNull(const ::network::mojom::SSLCertRequestInfoPtr& input) { return !input; }
  static void SetToNull(::network::mojom::SSLCertRequestInfoPtr* output) { output->reset(); }

  static const decltype(::network::mojom::SSLCertRequestInfo::host_and_port)& host_and_port(
      const ::network::mojom::SSLCertRequestInfoPtr& input) {
    return input->host_and_port;
  }

  static decltype(::network::mojom::SSLCertRequestInfo::is_proxy) is_proxy(
      const ::network::mojom::SSLCertRequestInfoPtr& input) {
    return input->is_proxy;
  }

  static const decltype(::network::mojom::SSLCertRequestInfo::cert_authorities)& cert_authorities(
      const ::network::mojom::SSLCertRequestInfoPtr& input) {
    return input->cert_authorities;
  }

  static const decltype(::network::mojom::SSLCertRequestInfo::signature_algorithms)& signature_algorithms(
      const ::network::mojom::SSLCertRequestInfoPtr& input) {
    return input->signature_algorithms;
  }

  static bool Read(::network::mojom::SSLCertRequestInfo::DataView input, ::network::mojom::SSLCertRequestInfoPtr* output);
};


template <>
struct  StructTraits<::network::mojom::NetLogSource::DataView,
                                         ::network::mojom::NetLogSourcePtr> {
  static bool IsNull(const ::network::mojom::NetLogSourcePtr& input) { return !input; }
  static void SetToNull(::network::mojom::NetLogSourcePtr* output) { output->reset(); }

  static decltype(::network::mojom::NetLogSource::source_type) source_type(
      const ::network::mojom::NetLogSourcePtr& input) {
    return input->source_type;
  }

  static decltype(::network::mojom::NetLogSource::source_id) source_id(
      const ::network::mojom::NetLogSourcePtr& input) {
    return input->source_id;
  }

  static const decltype(::network::mojom::NetLogSource::start_time)& start_time(
      const ::network::mojom::NetLogSourcePtr& input) {
    return input->start_time;
  }

  static bool Read(::network::mojom::NetLogSource::DataView input, ::network::mojom::NetLogSourcePtr* output);
};

}  // namespace mojo

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_PARAM_MOJOM_H_