// services/video_capture/public/mojom/video_effects_manager.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/video_capture/public/mojom/video_effects_manager.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/video_capture/public/mojom/video_effects_manager.mojom-params-data.h"
#include "services/video_capture/public/mojom/video_effects_manager.mojom-shared-message-ids.h"

#include "services/video_capture/public/mojom/video_effects_manager.mojom-import-headers.h"
#include "services/video_capture/public/mojom/video_effects_manager.mojom-test-utils.h"


namespace video_capture::mojom {
ImageEnhancement::ImageEnhancement()
    : lighting() {}

ImageEnhancement::ImageEnhancement(
    bool lighting_in)
    : lighting(std::move(lighting_in)) {}

ImageEnhancement::~ImageEnhancement() = default;
size_t ImageEnhancement::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->lighting);
  return seed;
}

void ImageEnhancement::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "lighting"), this->lighting,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ImageEnhancement::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Blur::Blur()
    : kernel(),
      sigma() {}

Blur::Blur(
    uint16_t kernel_in,
    float sigma_in)
    : kernel(std::move(kernel_in)),
      sigma(std::move(sigma_in)) {}

Blur::~Blur() = default;
size_t Blur::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->kernel);
  seed = mojo::internal::Hash(seed, this->sigma);
  return seed;
}

void Blur::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "kernel"), this->kernel,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint16_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "sigma"), this->sigma,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Blur::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Masking::Masking()
    : background_blur() {}

Masking::Masking(
    BlurPtr background_blur_in)
    : background_blur(std::move(background_blur_in)) {}

Masking::~Masking() = default;
size_t Masking::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->background_blur);
  return seed;
}

void Masking::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "background_blur"), this->background_blur,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type BlurPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Masking::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Framing::Framing()
    : padding_ratios() {}

Framing::Framing(
    const ::gfx::InsetsF& padding_ratios_in)
    : padding_ratios(std::move(padding_ratios_in)) {}

Framing::~Framing() = default;

void Framing::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "padding_ratios"), this->padding_ratios,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const ::gfx::InsetsF&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Framing::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
VideoEffectsConfiguration::VideoEffectsConfiguration()
    : image_enhancement(),
      masking(),
      framing() {}

VideoEffectsConfiguration::VideoEffectsConfiguration(
    ImageEnhancementPtr image_enhancement_in,
    MaskingPtr masking_in,
    FramingPtr framing_in)
    : image_enhancement(std::move(image_enhancement_in)),
      masking(std::move(masking_in)),
      framing(std::move(framing_in)) {}

VideoEffectsConfiguration::~VideoEffectsConfiguration() = default;

void VideoEffectsConfiguration::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "image_enhancement"), this->image_enhancement,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ImageEnhancementPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "masking"), this->masking,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type MaskingPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "framing"), this->framing,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type FramingPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool VideoEffectsConfiguration::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char VideoEffectsConfigurationObserver::Name_[] = "video_capture.mojom.VideoEffectsConfigurationObserver";

VideoEffectsConfigurationObserver::IPCStableHashFunction VideoEffectsConfigurationObserver::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kVideoEffectsConfigurationObserver_OnConfigurationChanged_Name: {
      return &VideoEffectsConfigurationObserver::OnConfigurationChanged_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* VideoEffectsConfigurationObserver::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kVideoEffectsConfigurationObserver_OnConfigurationChanged_Name:
            return "Receive video_capture::mojom::VideoEffectsConfigurationObserver::OnConfigurationChanged";
    }
  } else {
    switch (message.name()) {
      case internal::kVideoEffectsConfigurationObserver_OnConfigurationChanged_Name:
            return "Receive reply video_capture::mojom::VideoEffectsConfigurationObserver::OnConfigurationChanged";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t VideoEffectsConfigurationObserver::OnConfigurationChanged_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)video_capture::mojom::VideoEffectsConfigurationObserver::OnConfigurationChanged");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

VideoEffectsConfigurationObserverProxy::VideoEffectsConfigurationObserverProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void VideoEffectsConfigurationObserverProxy::OnConfigurationChanged(
    VideoEffectsConfigurationPtr in_configuration) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send video_capture::mojom::VideoEffectsConfigurationObserver::OnConfigurationChanged", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("configuration"), in_configuration,
                        "<value of type VideoEffectsConfigurationPtr>");
   });
#endif

  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kVideoEffectsConfigurationObserver_OnConfigurationChanged_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::video_capture::mojom::internal::VideoEffectsConfigurationObserver_OnConfigurationChanged_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->configuration)::BaseType> configuration_fragment(
          params.message());
  mojo::internal::Serialize<::video_capture::mojom::VideoEffectsConfigurationDataView>(
      in_configuration, configuration_fragment);
  params->configuration.Set(
      configuration_fragment.is_null() ? nullptr : configuration_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->configuration.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null configuration in VideoEffectsConfigurationObserver.OnConfigurationChanged request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(VideoEffectsConfigurationObserver::Name_);
  message.set_method_name("OnConfigurationChanged");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}

// static
bool VideoEffectsConfigurationObserverStubDispatch::Accept(
    VideoEffectsConfigurationObserver* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kVideoEffectsConfigurationObserver_OnConfigurationChanged_Name: {

      DCHECK(message->is_serialized());
      internal::VideoEffectsConfigurationObserver_OnConfigurationChanged_Params_Data* params =
          reinterpret_cast<internal::VideoEffectsConfigurationObserver_OnConfigurationChanged_Params_Data*>(
              message->mutable_payload());
      
      
      // Validation for VideoEffectsConfigurationObserver.0
      bool success = true;
      VideoEffectsConfigurationPtr p_configuration{};
      VideoEffectsConfigurationObserver_OnConfigurationChanged_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadConfiguration(&p_configuration))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            VideoEffectsConfigurationObserver::Name_, 0, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->OnConfigurationChanged(        
        std::move(p_configuration));
      return true;
    }
  }
  return false;
}

// static
bool VideoEffectsConfigurationObserverStubDispatch::AcceptWithResponder(
    VideoEffectsConfigurationObserver* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kVideoEffectsConfigurationObserver_OnConfigurationChanged_Name: {
      break;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kVideoEffectsConfigurationObserverValidationInfo[] = {
    {internal::kVideoEffectsConfigurationObserver_OnConfigurationChanged_Name,
     { &internal::VideoEffectsConfigurationObserver_OnConfigurationChanged_Params_Data::Validate,
      nullptr /* no response */}},
};

bool VideoEffectsConfigurationObserverRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::video_capture::mojom::VideoEffectsConfigurationObserver::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kVideoEffectsConfigurationObserverValidationInfo);
}

const char VideoEffectsManager::Name_[] = "video_capture.mojom.VideoEffectsManager";

VideoEffectsManager::IPCStableHashFunction VideoEffectsManager::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kVideoEffectsManager_GetConfiguration_Name: {
      return &VideoEffectsManager::GetConfiguration_Sym::IPCStableHash;
    }
    case internal::kVideoEffectsManager_SetConfiguration_Name: {
      return &VideoEffectsManager::SetConfiguration_Sym::IPCStableHash;
    }
    case internal::kVideoEffectsManager_AddObserver_Name: {
      return &VideoEffectsManager::AddObserver_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* VideoEffectsManager::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kVideoEffectsManager_GetConfiguration_Name:
            return "Receive video_capture::mojom::VideoEffectsManager::GetConfiguration";
      case internal::kVideoEffectsManager_SetConfiguration_Name:
            return "Receive video_capture::mojom::VideoEffectsManager::SetConfiguration";
      case internal::kVideoEffectsManager_AddObserver_Name:
            return "Receive video_capture::mojom::VideoEffectsManager::AddObserver";
    }
  } else {
    switch (message.name()) {
      case internal::kVideoEffectsManager_GetConfiguration_Name:
            return "Receive reply video_capture::mojom::VideoEffectsManager::GetConfiguration";
      case internal::kVideoEffectsManager_SetConfiguration_Name:
            return "Receive reply video_capture::mojom::VideoEffectsManager::SetConfiguration";
      case internal::kVideoEffectsManager_AddObserver_Name:
            return "Receive reply video_capture::mojom::VideoEffectsManager::AddObserver";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t VideoEffectsManager::GetConfiguration_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)video_capture::mojom::VideoEffectsManager::GetConfiguration");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t VideoEffectsManager::SetConfiguration_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)video_capture::mojom::VideoEffectsManager::SetConfiguration");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t VideoEffectsManager::AddObserver_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)video_capture::mojom::VideoEffectsManager::AddObserver");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class VideoEffectsManager_GetConfiguration_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  VideoEffectsManager_GetConfiguration_ForwardToCallback(
      VideoEffectsManager::GetConfigurationCallback callback
      ) : callback_(std::move(callback)) {
  }

  VideoEffectsManager_GetConfiguration_ForwardToCallback(const VideoEffectsManager_GetConfiguration_ForwardToCallback&) = delete;
  VideoEffectsManager_GetConfiguration_ForwardToCallback& operator=(const VideoEffectsManager_GetConfiguration_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  VideoEffectsManager::GetConfigurationCallback callback_;
};

class VideoEffectsManager_SetConfiguration_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  VideoEffectsManager_SetConfiguration_ForwardToCallback(
      VideoEffectsManager::SetConfigurationCallback callback
      ) : callback_(std::move(callback)) {
  }

  VideoEffectsManager_SetConfiguration_ForwardToCallback(const VideoEffectsManager_SetConfiguration_ForwardToCallback&) = delete;
  VideoEffectsManager_SetConfiguration_ForwardToCallback& operator=(const VideoEffectsManager_SetConfiguration_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  VideoEffectsManager::SetConfigurationCallback callback_;
};

VideoEffectsManagerProxy::VideoEffectsManagerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void VideoEffectsManagerProxy::GetConfiguration(
    GetConfigurationCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "Send video_capture::mojom::VideoEffectsManager::GetConfiguration");
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kVideoEffectsManager_GetConfiguration_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::video_capture::mojom::internal::VideoEffectsManager_GetConfiguration_Params_Data> params(
          message);
  params.Allocate();

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(VideoEffectsManager::Name_);
  message.set_method_name("GetConfiguration");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new VideoEffectsManager_GetConfiguration_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}

void VideoEffectsManagerProxy::SetConfiguration(
    VideoEffectsConfigurationPtr in_configuration, SetConfigurationCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send video_capture::mojom::VideoEffectsManager::SetConfiguration", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("configuration"), in_configuration,
                        "<value of type VideoEffectsConfigurationPtr>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kVideoEffectsManager_SetConfiguration_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::video_capture::mojom::internal::VideoEffectsManager_SetConfiguration_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->configuration)::BaseType> configuration_fragment(
          params.message());
  mojo::internal::Serialize<::video_capture::mojom::VideoEffectsConfigurationDataView>(
      in_configuration, configuration_fragment);
  params->configuration.Set(
      configuration_fragment.is_null() ? nullptr : configuration_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->configuration.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null configuration in VideoEffectsManager.SetConfiguration request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(VideoEffectsManager::Name_);
  message.set_method_name("SetConfiguration");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new VideoEffectsManager_SetConfiguration_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}

void VideoEffectsManagerProxy::AddObserver(
    ::mojo::PendingRemote<VideoEffectsConfigurationObserver> in_observer) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send video_capture::mojom::VideoEffectsManager::AddObserver", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("observer"), in_observer,
                        "<value of type ::mojo::PendingRemote<VideoEffectsConfigurationObserver>>");
   });
#endif

  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kVideoEffectsManager_AddObserver_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::video_capture::mojom::internal::VideoEffectsManager_AddObserver_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<mojo::InterfacePtrDataView<::video_capture::mojom::VideoEffectsConfigurationObserverInterfaceBase>>(
      in_observer, &params->observer, &params.message());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->observer),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid observer in VideoEffectsManager.AddObserver request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(VideoEffectsManager::Name_);
  message.set_method_name("AddObserver");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ::mojo::internal::SendMojoMessage(*receiver_, message);
}
class VideoEffectsManager_GetConfiguration_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static VideoEffectsManager::GetConfigurationCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<VideoEffectsManager_GetConfiguration_ProxyToResponder> proxy(
        new VideoEffectsManager_GetConfiguration_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&VideoEffectsManager_GetConfiguration_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~VideoEffectsManager_GetConfiguration_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  VideoEffectsManager_GetConfiguration_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
//    DCHECK(!connected)
//        << "VideoEffectsManager::GetConfigurationCallback was destroyed without "
//        << "first either being run or its corresponding binding being closed. "
//        << "It is an error to drop response callbacks which still correspond "
//        << "to an open interface pipe.";
  }
#endif

  void Run(
      VideoEffectsConfigurationPtr in_configuration);
};

bool VideoEffectsManager_GetConfiguration_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::VideoEffectsManager_GetConfiguration_ResponseParams_Data* params =
      reinterpret_cast<
          internal::VideoEffectsManager_GetConfiguration_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for VideoEffectsManager.0
  bool success = true;
  VideoEffectsConfigurationPtr p_configuration{};
  VideoEffectsManager_GetConfiguration_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadConfiguration(&p_configuration))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        VideoEffectsManager::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_configuration));
  return true;
}

void VideoEffectsManager_GetConfiguration_ProxyToResponder::Run(
    VideoEffectsConfigurationPtr in_configuration) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply video_capture::mojom::VideoEffectsManager::GetConfiguration", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("configuration"), in_configuration,
                        "<value of type VideoEffectsConfigurationPtr>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kVideoEffectsManager_GetConfiguration_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::video_capture::mojom::internal::VideoEffectsManager_GetConfiguration_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->configuration)::BaseType> configuration_fragment(
          params.message());
  mojo::internal::Serialize<::video_capture::mojom::VideoEffectsConfigurationDataView>(
      in_configuration, configuration_fragment);
  params->configuration.Set(
      configuration_fragment.is_null() ? nullptr : configuration_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->configuration.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null configuration in ");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(VideoEffectsManager::Name_);
  message.set_method_name("GetConfiguration");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class VideoEffectsManager_SetConfiguration_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static VideoEffectsManager::SetConfigurationCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<VideoEffectsManager_SetConfiguration_ProxyToResponder> proxy(
        new VideoEffectsManager_SetConfiguration_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&VideoEffectsManager_SetConfiguration_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~VideoEffectsManager_SetConfiguration_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  VideoEffectsManager_SetConfiguration_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
//    DCHECK(!connected)
//        << "VideoEffectsManager::SetConfigurationCallback was destroyed without "
//        << "first either being run or its corresponding binding being closed. "
//        << "It is an error to drop response callbacks which still correspond "
//        << "to an open interface pipe.";
  }
#endif

  void Run(
      SetConfigurationResult in_result);
};

bool VideoEffectsManager_SetConfiguration_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::VideoEffectsManager_SetConfiguration_ResponseParams_Data* params =
      reinterpret_cast<
          internal::VideoEffectsManager_SetConfiguration_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for VideoEffectsManager.1
  bool success = true;
  SetConfigurationResult p_result{};
  VideoEffectsManager_SetConfiguration_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        VideoEffectsManager::Name_, 1, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result));
  return true;
}

void VideoEffectsManager_SetConfiguration_ProxyToResponder::Run(
    SetConfigurationResult in_result) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply video_capture::mojom::VideoEffectsManager::SetConfiguration", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), in_result,
                        "<value of type SetConfigurationResult>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kVideoEffectsManager_SetConfiguration_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::video_capture::mojom::internal::VideoEffectsManager_SetConfiguration_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<::video_capture::mojom::SetConfigurationResult>(
      in_result, &params->result);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(VideoEffectsManager::Name_);
  message.set_method_name("SetConfiguration");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool VideoEffectsManagerStubDispatch::Accept(
    VideoEffectsManager* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kVideoEffectsManager_GetConfiguration_Name: {
      break;
    }
    case internal::kVideoEffectsManager_SetConfiguration_Name: {
      break;
    }
    case internal::kVideoEffectsManager_AddObserver_Name: {

      DCHECK(message->is_serialized());
      internal::VideoEffectsManager_AddObserver_Params_Data* params =
          reinterpret_cast<internal::VideoEffectsManager_AddObserver_Params_Data*>(
              message->mutable_payload());
      
      
      // Validation for VideoEffectsManager.2
      bool success = true;
      ::mojo::PendingRemote<VideoEffectsConfigurationObserver> p_observer{};
      VideoEffectsManager_AddObserver_ParamsDataView input_data_view(params, message);
      
      if (success) {
        p_observer =
            input_data_view.TakeObserver<decltype(p_observer)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            VideoEffectsManager::Name_, 2, false);
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->AddObserver(        
        std::move(p_observer));
      return true;
    }
  }
  return false;
}

// static
bool VideoEffectsManagerStubDispatch::AcceptWithResponder(
    VideoEffectsManager* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kVideoEffectsManager_GetConfiguration_Name: {

      internal::VideoEffectsManager_GetConfiguration_Params_Data* params =
          reinterpret_cast<
              internal::VideoEffectsManager_GetConfiguration_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for VideoEffectsManager.0
      bool success = true;
      VideoEffectsManager_GetConfiguration_ParamsDataView input_data_view(params, message);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            VideoEffectsManager::Name_, 0, false);
        return false;
      }
      VideoEffectsManager::GetConfigurationCallback callback =
          VideoEffectsManager_GetConfiguration_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetConfiguration(std::move(callback));
      return true;
    }
    case internal::kVideoEffectsManager_SetConfiguration_Name: {

      internal::VideoEffectsManager_SetConfiguration_Params_Data* params =
          reinterpret_cast<
              internal::VideoEffectsManager_SetConfiguration_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for VideoEffectsManager.1
      bool success = true;
      VideoEffectsConfigurationPtr p_configuration{};
      VideoEffectsManager_SetConfiguration_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadConfiguration(&p_configuration))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            VideoEffectsManager::Name_, 1, false);
        return false;
      }
      VideoEffectsManager::SetConfigurationCallback callback =
          VideoEffectsManager_SetConfiguration_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetConfiguration(        
        std::move(p_configuration), std::move(callback));
      return true;
    }
    case internal::kVideoEffectsManager_AddObserver_Name: {
      break;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kVideoEffectsManagerValidationInfo[] = {
    {internal::kVideoEffectsManager_GetConfiguration_Name,
     { &internal::VideoEffectsManager_GetConfiguration_Params_Data::Validate,
      &internal::VideoEffectsManager_GetConfiguration_ResponseParams_Data::Validate}},
    {internal::kVideoEffectsManager_SetConfiguration_Name,
     { &internal::VideoEffectsManager_SetConfiguration_Params_Data::Validate,
      &internal::VideoEffectsManager_SetConfiguration_ResponseParams_Data::Validate}},
    {internal::kVideoEffectsManager_AddObserver_Name,
     { &internal::VideoEffectsManager_AddObserver_Params_Data::Validate,
      nullptr /* no response */}},
};

bool VideoEffectsManagerRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::video_capture::mojom::VideoEffectsManager::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kVideoEffectsManagerValidationInfo);
}

bool VideoEffectsManagerResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::video_capture::mojom::VideoEffectsManager::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kVideoEffectsManagerValidationInfo);

}


}  // video_capture::mojom


namespace mojo {


// static
bool StructTraits<::video_capture::mojom::ImageEnhancement::DataView, ::video_capture::mojom::ImageEnhancementPtr>::Read(
    ::video_capture::mojom::ImageEnhancement::DataView input,
    ::video_capture::mojom::ImageEnhancementPtr* output) {
  bool success = true;
  ::video_capture::mojom::ImageEnhancementPtr result(::video_capture::mojom::ImageEnhancement::New());
  
      if (success)
        result->lighting = input.lighting();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::video_capture::mojom::Blur::DataView, ::video_capture::mojom::BlurPtr>::Read(
    ::video_capture::mojom::Blur::DataView input,
    ::video_capture::mojom::BlurPtr* output) {
  bool success = true;
  ::video_capture::mojom::BlurPtr result(::video_capture::mojom::Blur::New());
  
      if (success)
        result->kernel = input.kernel();
      if (success)
        result->sigma = input.sigma();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::video_capture::mojom::Masking::DataView, ::video_capture::mojom::MaskingPtr>::Read(
    ::video_capture::mojom::Masking::DataView input,
    ::video_capture::mojom::MaskingPtr* output) {
  bool success = true;
  ::video_capture::mojom::MaskingPtr result(::video_capture::mojom::Masking::New());
  
      if (success && !input.ReadBackgroundBlur(&result->background_blur))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::video_capture::mojom::Framing::DataView, ::video_capture::mojom::FramingPtr>::Read(
    ::video_capture::mojom::Framing::DataView input,
    ::video_capture::mojom::FramingPtr* output) {
  bool success = true;
  ::video_capture::mojom::FramingPtr result(::video_capture::mojom::Framing::New());
  
      if (success && !input.ReadPaddingRatios(&result->padding_ratios))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::video_capture::mojom::VideoEffectsConfiguration::DataView, ::video_capture::mojom::VideoEffectsConfigurationPtr>::Read(
    ::video_capture::mojom::VideoEffectsConfiguration::DataView input,
    ::video_capture::mojom::VideoEffectsConfigurationPtr* output) {
  bool success = true;
  ::video_capture::mojom::VideoEffectsConfigurationPtr result(::video_capture::mojom::VideoEffectsConfiguration::New());
  
      if (success && !input.ReadImageEnhancement(&result->image_enhancement))
        success = false;
      if (success && !input.ReadMasking(&result->masking))
        success = false;
      if (success && !input.ReadFraming(&result->framing))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace video_capture::mojom {


void VideoEffectsConfigurationObserverInterceptorForTesting::OnConfigurationChanged(VideoEffectsConfigurationPtr configuration) {
  GetForwardingInterface()->OnConfigurationChanged(std::move(configuration));
}
VideoEffectsConfigurationObserverAsyncWaiter::VideoEffectsConfigurationObserverAsyncWaiter(
    VideoEffectsConfigurationObserver* proxy) : proxy_(proxy) {}

VideoEffectsConfigurationObserverAsyncWaiter::~VideoEffectsConfigurationObserverAsyncWaiter() = default;




void VideoEffectsManagerInterceptorForTesting::GetConfiguration(GetConfigurationCallback callback) {
  GetForwardingInterface()->GetConfiguration(std::move(callback));
}
void VideoEffectsManagerInterceptorForTesting::SetConfiguration(VideoEffectsConfigurationPtr configuration, SetConfigurationCallback callback) {
  GetForwardingInterface()->SetConfiguration(std::move(configuration), std::move(callback));
}
void VideoEffectsManagerInterceptorForTesting::AddObserver(::mojo::PendingRemote<VideoEffectsConfigurationObserver> observer) {
  GetForwardingInterface()->AddObserver(std::move(observer));
}
VideoEffectsManagerAsyncWaiter::VideoEffectsManagerAsyncWaiter(
    VideoEffectsManager* proxy) : proxy_(proxy) {}

VideoEffectsManagerAsyncWaiter::~VideoEffectsManagerAsyncWaiter() = default;

void VideoEffectsManagerAsyncWaiter::GetConfiguration(
    VideoEffectsConfigurationPtr* out_configuration) {
  base::RunLoop loop;
  proxy_->GetConfiguration(
      base::BindOnce(
          [](base::RunLoop* loop,
             VideoEffectsConfigurationPtr* out_configuration
,
             VideoEffectsConfigurationPtr configuration) {*out_configuration = std::move(configuration);
            loop->Quit();
          },
          &loop,
          out_configuration));
  loop.Run();
}

VideoEffectsConfigurationPtr VideoEffectsManagerAsyncWaiter::GetConfiguration(
    ) {
  VideoEffectsConfigurationPtr async_wait_result;
  GetConfiguration(&async_wait_result);
  return async_wait_result;
}

void VideoEffectsManagerAsyncWaiter::SetConfiguration(
    VideoEffectsConfigurationPtr configuration, SetConfigurationResult* out_result) {
  base::RunLoop loop;
  proxy_->SetConfiguration(std::move(configuration),
      base::BindOnce(
          [](base::RunLoop* loop,
             SetConfigurationResult* out_result
,
             SetConfigurationResult result) {*out_result = std::move(result);
            loop->Quit();
          },
          &loop,
          out_result));
  loop.Run();
}

SetConfigurationResult VideoEffectsManagerAsyncWaiter::SetConfiguration(
    VideoEffectsConfigurationPtr configuration) {
  SetConfigurationResult async_wait_result;
  SetConfiguration(std::move(configuration),&async_wait_result);
  return async_wait_result;
}






}  // video_capture::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif