// services/viz/public/mojom/compositing/layer_context.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_LAYER_CONTEXT_MOJOM_SHARED_H_
#define SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_LAYER_CONTEXT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/viz/public/mojom/compositing/layer_context.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojom/geometry.mojom-shared.h"
#include "services/viz/public/mojom/compositing/begin_frame_args.mojom-shared.h"
#include "services/viz/public/mojom/compositing/local_surface_id.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace viz::mojom {
class LayerTreeUpdateDataView;

class PendingLayerContextDataView;



}  // viz::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::viz::mojom::LayerTreeUpdateDataView> {
  using Data = ::viz::mojom::internal::LayerTreeUpdate_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::viz::mojom::PendingLayerContextDataView> {
  using Data = ::viz::mojom::internal::PendingLayerContext_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace viz::mojom {
// Interface base classes. They are used for type safety check.
class LayerContextInterfaceBase {};

using LayerContextPtrDataView =
    mojo::InterfacePtrDataView<LayerContextInterfaceBase>;
using LayerContextRequestDataView =
    mojo::InterfaceRequestDataView<LayerContextInterfaceBase>;
using LayerContextAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<LayerContextInterfaceBase>;
using LayerContextAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<LayerContextInterfaceBase>;
class LayerContextClientInterfaceBase {};

using LayerContextClientPtrDataView =
    mojo::InterfacePtrDataView<LayerContextClientInterfaceBase>;
using LayerContextClientRequestDataView =
    mojo::InterfaceRequestDataView<LayerContextClientInterfaceBase>;
using LayerContextClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<LayerContextClientInterfaceBase>;
using LayerContextClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<LayerContextClientInterfaceBase>;


class LayerTreeUpdateDataView {
 public:
  LayerTreeUpdateDataView() = default;

  LayerTreeUpdateDataView(
      internal::LayerTreeUpdate_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetDeviceViewportDataView(
      ::gfx::mojom::RectDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDeviceViewport(UserType* output) {
    
    auto* pointer = data_->device_viewport.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectDataView>(
        pointer, output, message_);
  }
  float device_scale_factor() const {
    return data_->device_scale_factor;
  }
  inline void GetLocalSurfaceIdFromParentDataView(
      ::viz::mojom::LocalSurfaceIdDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadLocalSurfaceIdFromParent(UserType* output) {
    
    auto* pointer = data_->local_surface_id_from_parent.Get();
    return mojo::internal::Deserialize<::viz::mojom::LocalSurfaceIdDataView>(
        pointer, output, message_);
  }
 private:
  internal::LayerTreeUpdate_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


class PendingLayerContextDataView {
 public:
  PendingLayerContextDataView() = default;

  PendingLayerContextDataView(
      internal::PendingLayerContext_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeReceiver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::viz::mojom::LayerContextAssociatedRequestDataView>(
            &data_->receiver, &result, message_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::viz::mojom::LayerContextClientAssociatedPtrInfoDataView>(
            &data_->client, &result, message_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::PendingLayerContext_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // viz::mojom

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::viz::mojom::LayerTreeUpdateDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::viz::mojom::LayerTreeUpdateDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::viz::mojom::internal::LayerTreeUpdate_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::device_viewport(input)) in_device_viewport = Traits::device_viewport(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->device_viewport)::BaseType> device_viewport_fragment(
            fragment.message());
    mojo::internal::Serialize<::gfx::mojom::RectDataView>(
        in_device_viewport, device_viewport_fragment);
    fragment->device_viewport.Set(
        device_viewport_fragment.is_null() ? nullptr : device_viewport_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->device_viewport.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null device_viewport in LayerTreeUpdate struct");
    fragment->device_scale_factor = Traits::device_scale_factor(input);
    decltype(Traits::local_surface_id_from_parent(input)) in_local_surface_id_from_parent = Traits::local_surface_id_from_parent(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->local_surface_id_from_parent)::BaseType> local_surface_id_from_parent_fragment(
            fragment.message());
    mojo::internal::Serialize<::viz::mojom::LocalSurfaceIdDataView>(
        in_local_surface_id_from_parent, local_surface_id_from_parent_fragment);
    fragment->local_surface_id_from_parent.Set(
        local_surface_id_from_parent_fragment.is_null() ? nullptr : local_surface_id_from_parent_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->local_surface_id_from_parent.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null local_surface_id_from_parent in LayerTreeUpdate struct");
  }

  static bool Deserialize(::viz::mojom::internal::LayerTreeUpdate_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::viz::mojom::LayerTreeUpdateDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::viz::mojom::PendingLayerContextDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::viz::mojom::PendingLayerContextDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::viz::mojom::internal::PendingLayerContext_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::receiver(input)) in_receiver = Traits::receiver(input);
    mojo::internal::Serialize<::viz::mojom::LayerContextAssociatedRequestDataView>(
        in_receiver, &fragment->receiver, &fragment.message());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid(fragment->receiver),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
        "invalid receiver in PendingLayerContext struct");
    decltype(Traits::client(input)) in_client = Traits::client(input);
    mojo::internal::Serialize<::viz::mojom::LayerContextClientAssociatedPtrInfoDataView>(
        in_client, &fragment->client, &fragment.message());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        !mojo::internal::IsHandleOrInterfaceValid(fragment->client),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_INTERFACE_ID,
        "invalid client in PendingLayerContext struct");
  }

  static bool Deserialize(::viz::mojom::internal::PendingLayerContext_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::viz::mojom::PendingLayerContextDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace viz::mojom {

inline void LayerTreeUpdateDataView::GetDeviceViewportDataView(
    ::gfx::mojom::RectDataView* output) {
  auto pointer = data_->device_viewport.Get();
  *output = ::gfx::mojom::RectDataView(pointer, message_);
}
inline void LayerTreeUpdateDataView::GetLocalSurfaceIdFromParentDataView(
    ::viz::mojom::LocalSurfaceIdDataView* output) {
  auto pointer = data_->local_surface_id_from_parent.Get();
  *output = ::viz::mojom::LocalSurfaceIdDataView(pointer, message_);
}





}  // viz::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

#endif  // SERVICES_VIZ_PUBLIC_MOJOM_COMPOSITING_LAYER_CONTEXT_MOJOM_SHARED_H_