// third_party/blink/public/mojom/frame/view_transition_state.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/public/mojom/frame/view_transition_state.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "third_party/blink/public/mojom/frame/view_transition_state.mojom-params-data.h"
namespace blink {
namespace mojom {

NOINLINE static const char* ViewTransitionPropertyIdToStringHelper(ViewTransitionPropertyId value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case ViewTransitionPropertyId::kBackdropFilter:
      return "kBackdropFilter";
    case ViewTransitionPropertyId::kColorScheme:
      return "kColorScheme";
    case ViewTransitionPropertyId::kMixBlendMode:
      return "kMixBlendMode";
    case ViewTransitionPropertyId::kTextOrientation:
      return "kTextOrientation";
    case ViewTransitionPropertyId::kWritingMode:
      return "kWritingMode";
    default:
      return nullptr;
  }
}

std::string ViewTransitionPropertyIdToString(ViewTransitionPropertyId value) {
  const char *str = ViewTransitionPropertyIdToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown ViewTransitionPropertyId value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, ViewTransitionPropertyId value) {
  return os << ViewTransitionPropertyIdToString(value);
}

namespace internal {


// static
bool ViewTransitionElement_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 72, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ViewTransitionElement_Data* object =
      static_cast<const ViewTransitionElement_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->tag_name, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& tag_name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->tag_name, validation_context,
                                         &tag_name_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->border_box_size_in_css_space, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->border_box_size_in_css_space, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->viewport_matrix, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->viewport_matrix, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->overflow_rect_in_layout_space, 4, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->overflow_rect_in_layout_space, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->captured_rect_in_layout_space, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->snapshot_id, 6, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->snapshot_id, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->captured_css_properties, 8, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& captured_css_properties_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayOfEnumsValidator<0, ::blink::mojom::internal::ViewTransitionPropertyId_Data::Validate>(), *&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>()>();
  if (!mojo::internal::ValidateContainer(object->captured_css_properties, validation_context,
                                         &captured_css_properties_validate_params)) {
    return false;
  }

  return true;
}

ViewTransitionElement_Data::ViewTransitionElement_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ViewTransitionState_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 40, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ViewTransitionState_Data* object =
      static_cast<const ViewTransitionState_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->elements, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& elements_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->elements, validation_context,
                                         &elements_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->navigation_id, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->navigation_id, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->snapshot_root_size_at_capture, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->snapshot_root_size_at_capture, validation_context))
    return false;

  return true;
}

ViewTransitionState_Data::ViewTransitionState_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace blink

namespace perfetto {

// static
void TraceFormatTraits<::blink::mojom::ViewTransitionPropertyId>::WriteIntoTrace(
   perfetto::TracedValue context, ::blink::mojom::ViewTransitionPropertyId value) {
  return std::move(context).WriteString(::blink::mojom::ViewTransitionPropertyIdToString(value));
}

} // namespace perfetto